

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}


--======================================================================VALUES========================================================================
local gravelext = 		sounds.createSFXSource('art/sound/gravelext.ogg', 		'AudioDefaultLoop3D', 	"gravelext", 		v.data.refNodes[0].ref)
local gravelext2 = 		sounds.createSFXSource('art/sound/gravelext2.ogg', 		'AudioDefaultLoop3D', 	"gravelext2", 		v.data.refNodes[0].ref)
local gravelInt = 	 	sounds.createSFXSource('art/sound/gravelint.ogg', 		'AudioDefaultLoop3D', 	"gravelint", 		v.data.refNodes[0].ref)
local gravelSkid =	 	sounds.createSFXSource('art/sound/skid_gravel2.ogg', 	'AudioDefaultLoop3D', 	"gravelskid", 		v.data.refNodes[0].ref)
local waterSound =  	sounds.createSFXSource('art/sound/water.ogg', 			'AudioDefaultLoop3D', 	"WaterSound",		v.data.refNodes[0].ref)		
local waterSplash = 	sounds.createSFXSource('art/sound/watersplash.ogg', 	'AudioDefault3D', 		"Watersplash", 		v.data.refNodes[0].ref)
local woosh = 			sounds.createSFXSource('art/sound/woosh.ogg', 		    'AudioDefault3D',       "woosh",			v.data.refNodes[0].ref)
local settingsUser =    readJsonFile("/mods/sirenmod/config/settings.json")

local cameraMode
local sounds = require("sounds")
local delay = 0
local delaySkid = 0
local delayUnderWater = 0
local stillUnderWater = 0
local carName
local iTable = {} -- Contain all tire timers
local iTableSave
local iTableBoolean = false
local fadeSoundWater = 0
local fadeSoundDirt = 0
local fadeSoundDirtEnter = 0
--======================================================================VALUES========================================================================







local function onVehicleSwitched()	
		if settingsUser.VehicleSwitchSound == "true" and settingsUser.VehicleSwitchSound ~= nil then
			sounds.playSoundOnceAtNode("woosh", v.data.refNodes[0].ref,  tonumber(settingsUser.VehicleSwitchSoundVolume))	
		end
		obj:queueGameEngineLua("core_camera.switchCamera(0, 1) 	core_camera.switchCamera(0, -1)")
end





--=========================================INITILIZATION===========================================
local function onInit()
	iTable = {}
	obj:setVolumePitch(gravelInt, 0, 1)
	obj:setVolumePitch(gravelSkid, 0, 1)
	obj:setVolumePitch(gravelext, 0, 1)
	obj:setVolumePitch(gravelext2, 0, 1)
end
--=========================================INITILIZATION===========================================

local function onUpdate(dt)

	obj:queueGameEngineLua("be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switchActual = (\"'..be:getPlayerVehicleID(0)..'\") end ')")
	if drivingSounds.switch == nil then drivingSounds.switch = drivingSounds.switchActual end
	if drivingSounds.switchActual ~= drivingSounds.switch then
		drivingSounds.cameraMode = "orbit"
	end

	if 2-electrics.values.wheelspeed/10 > 0.15 then
		tireTimerThreshold = 2-electrics.values.wheelspeed/10
	end




	
	
--============================SOME CODE FROM DEV==============================		
	local overallWheelSlip = 0
	local lostGroundContact = false	
	for _, wi in ipairs(wheels.wheels) do	
	
		if wi.isPropulsed then
			if wi.contactMaterialID1 >= 0 and wi.contactDepth == 0 then
				overallWheelSlip = overallWheelSlip + wi.slipEnergy
			end
			lostGroundContact = wi.downForceRaw < 1 or lostGroundContact
		end
	
		local w = wi.obj	
		local underWater = obj:inWater(wi.node1) and 1 or 0
		local velocity = vec3(obj:getVelocity()):length()
		local wheelspeed = math.abs(w.angularVelocity * wi.radius)			
		if iTable[wi] == nil then 
			iTable[wi] = 1
		end		
--============================SOME CODE FROM DEV==============================

		
--====================================================================TIRE SMOKE======================================================================		
		if settingsUser.TireSmoke == "true" and settingsUser.TireSmoke ~= nil then -- If user enabled tire smoke
		
			if wi.contactMaterialID1 == 10 and wi.contactMaterialID2 == 4 and wi.contactDepth == 0  then --If drive on road
				if overallWheelSlip > 50000 then -- If skid vol and skid pitch mean that the player is drifting
					iTableBoolean = false
					if iTable[wi] < 35 then iTable[wi] = iTable[wi] + dt end -- Increase delay
					
					if iTable[wi] > 5 and iTable[wi] < 15 then -- If player is drifting more than 3s then
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 35, 1, 1) -- Spawn particles
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 22, 1, 1) end
			  
					if iTable[wi] > 15 and iTable[wi] < 25 then -- If player is drifting more than 15s then
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 6, 1, 1)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 35, 1, 1)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 22, 1, 1) end
			  
					if iTable[wi] > 25 then -- If player is drifting more than 25s then
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 35, 1, 1)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 37, 1, 1) end
						-- Here i wanted to have a chance to explode the tire but i don't know how to explode only the tire that is drifting
						-- Because the tire explode function use 0,1,2 or 3 to define tire and wi.node1 use the tire node number (like 103 or 250)
				elseif overallWheelSlip < 50000 and iTable[wi] > 1 then
				
				iTable[wi] = iTable[wi] - dt -- Reduce the delay slowly when the player stop drifting
				
				if iTable[wi] > 15 then -- If user drift over more than 15s
					if iTableBoolean == false then iTableSave = iTable[wi] iTableBoolean = true end -- Save iTableSave
					if iTableSave < iTable[wi] + 4 then -- Smoke come frome wheel for 3s
						if math.random(10) == 5 then -- Generate smoke
							obj:addParticleByNodesRelative(wi.node1, wi.node2, 4, 22, 0.4, 2)
							obj:addParticleByNodesRelative(wi.node1, wi.node2, 4, 6, 0.2, 2)
						end
					end
				end
				
				end
			end
			
		end
--====================================================================TIRE SMOKE======================================================================				
		
		
		

		
		

--============================================================================WATER PARTICLES AND SOUND============================================================================	
		if underWater == 1 or wi.contactMaterialID1 == 12 or wi.contactMaterialID1 == 11 then	-- If the vehicle is under water
		
			local wheelspeed = math.abs(w.angularVelocity * wi.radius) -- Get wheel speed
			iTable[wi] = 1
			
			if wi.isBroken == false and settingsUser.WaterSound == "true" and settingsUser.WaterSound ~= nil then -- If user enabled water sound and wheel is not broken
				if drivingSounds.cameraMode == "dash" then
					obj:setVolumePitch(waterSound, velocity/8+wheelspeed/8, velocity/7+wheelspeed/7) -- Set the water sound quieter if first person
					fadeSoundWater = velocity/8+wheelspeed/8
				else
					obj:setVolumePitch(waterSound, velocity/14+wheelspeed/14, velocity/4+wheelspeed/4) 
					fadeSoundWater = velocity/14+wheelspeed/14
				end		
			end
			
			if wi.isBroken == false and settingsUser.WaterParticles == "true" and settingsUser.WaterParticles ~= nil then -- If user enabled water particles and wheel is not broken
				local particlesAmount = wheelspeed/3
				if particlesAmount > 4 then particlesAmount = 4 end
				obj:addParticleByNodesRelative(wi.node1, wi.node2, -math.abs(wheelspeed/5), 50, 0.3, particlesAmount) -- Particles while driving in water
			end
			
			if stillUnderWater == 0 then				
				delayUnderWater = 0
				if wi.isBroken == false and velocity > 10 then -- If wheel is not broken and vehicle go fast
					if settingsUser.WaterParticles == "true" and settingsUser.WaterParticles ~= nil then -- If user enabled water particles
						local particlesSpeed = velocity / 6
						if particlesSpeed > 3 then particlesSpeed = 3 end
						obj:addParticleByNodesRelative(wi.node1, wi.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wi.node1, wi.node2, particlesSpeed, 50, 1, 10)	-- (Much) Particles when fall in water
					end
					if settingsUser.WaterSound == "true" and settingsUser.WaterSound ~= nil and underWater == 1 then -- If user enabled water sound
							sounds.playSoundOnceAtNode("waterSplash", v.data.refNodes[0].ref, velocity/20)	
					end
				end
				stillUnderWater = 1
			end		
		else
			if delayUnderWater > 2 then -- Small delay to prevent sound playing more than 1 time
				stillUnderWater = 0
				if fadeSoundWater > 0 then 
					obj:setVolumePitch(waterSound, fadeSoundWater, 1)
					fadeSoundWater = fadeSoundWater - dt
				end
			else delayUnderWater = delayUnderWater + dt end	
		end	

		if settingsUser.DirtSandParticles == "true" and settingsUser.DirtSandParticles ~= nil then -- If user enabled sand and dirt particles	
			if wi.contactMaterialID1 == 16 or wi.contactMaterialID1 == 20 or wi.contactMaterialID1 == 19 then -- If driving on sand or dirt	
				if velocity > 5 then -- If car is not stopped
					obj:addParticleByNodesRelative(1+math.random(10), wi.node2, 1-math.random(1) , 4, 0.3, wheelspeed/4) -- Dirt particles
				end
			end	
			if wi.contactMaterialID1 == 20 or wi.contactMaterialID1 == 19 then -- If drifting on dirt
				if overallWheelSlip > 80000 then
					obj:addParticleByNodesRelative(1+math.random(10), wi.node2, 1-math.random(1) , 4, 0.3, wheelspeed/4) -- Dirt particles
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 18, 0.3, 1) -- Dirt particles
				end
			end	
		end
--============================================================================WATER PARTICLES AND SOUND============================================================================			
	end		
end

M.onVehicleSwitched  = onVehicleSwitched
M.jsonInit	   		 = jsonInit
M.onUpdate	    	 = onUpdate
M.onReset 	   		 = onInit
M.focusLost    		 = focusLost
M.focusGained 		 = focusGained
M.updateGFX 		 = onUpdate

return M